#include < amxmodx >
#include < amxmisc >
#include < fakemeta >
#include < hamsandwich >
#include < engine >

#define PLUGIN "Admin knife"
#define VERSION "1.4"
#define AUTHOR "OverGame"

#define PL_PREFIX "[Админ нож]"
#define PL_LEVEL ADMIN_LEVEL_H

new knife [ 33 ];

public plugin_init ()
{
	register_plugin ( PLUGIN, VERSION, AUTHOR );
	
	register_clcmd ( "say /aknife", "func_user_knife" );
	register_clcmd ( "say_team /aknife", "func_user_knife" );
	
	RegisterHam ( Ham_Item_Deploy, "weapon_knife", "fwd_HamDeployKnife", 1 );
}

public plugin_cfg ()
{
	new szCfgDir [ 64 ], szFile [ 192 ];
	get_configsdir ( szCfgDir, charsmax ( szCfgDir ) );
	format ( szFile, charsmax ( szFile ), "%s/aknife.cfg", szCfgDir );
	
	if ( file_exists ( szFile ) )
		server_cmd ( "exec %s", szFile );
}

public plugin_precache ()
{
	register_cvar ( "aknife_model", "1" );
	register_cvar ( "aknife_auto_set", "1" );
	register_cvar ( "aknife_view_model", "models/aknife/v_knife.mdl" );
	register_cvar ( "aknife_player_model", "models/aknife/p_knife.mdl" );
	plugin_cfg ();
	
	if ( get_cvar_num ( "aknife_model" ) )
	{
		new szMdl [ 2 ][ 255 ];
		get_cvar_string ( "aknife_view_model", szMdl [ 0 ], charsmax ( szMdl [] ) );
		get_cvar_string ( "aknife_player_model", szMdl [ 1 ], charsmax ( szMdl [] ) );
		
		precache_model ( szMdl [ 0 ] );
		precache_model ( szMdl [ 1 ] );
	}
}

public fwd_HamDeployKnife ( weapon )
{
	new id = get_pdata_cbase ( weapon, 41, 4 );
	if ( !is_user_connected ( id ) || !is_user_alive ( id ) || !(get_user_flags ( id ) & PL_LEVEL) )
		return HAM_IGNORED;
	
	set_user_knife ( id );
	return HAM_IGNORED;
}

public client_putinserver ( id )
{
	if ( get_user_flags ( id ) & PL_LEVEL )
		knife [ id ] = get_cvar_num ( "aknife_auto_set" );
}

public client_PreThink ( id )
{
	if ( knife [ id ] == 1 && is_user_alive ( id ) )
	{
		entity_set_float ( id, EV_FL_fuser2, 0.0 );
		if ( entity_get_int ( id, EV_INT_button ) & 2 )
		{
			new flags = entity_get_int ( id, EV_INT_flags );
			if ( flags & FL_WATERJUMP )
				return PLUGIN_CONTINUE;
				
			if ( entity_get_int ( id, EV_INT_waterlevel ) >= 2 )
				return PLUGIN_CONTINUE;
				
			if ( !(flags & FL_ONGROUND) )
				return PLUGIN_CONTINUE;
				
			new Float:velocity [ 3 ];
			entity_get_vector ( id, EV_VEC_velocity, velocity );
			velocity [ 2 ] += 250.0;
			entity_set_vector ( id, EV_VEC_velocity, velocity );

			entity_set_int ( id, EV_INT_gaitsequence, 6 );
		}
	}
	
	return PLUGIN_CONTINUE;
}

public func_user_knife ( id )
{
	switch ( knife [ id ] )
	{
		case 0: { knife [ id ]++; }
		case 1: { knife [ id ] = 0; }
	}
	
	client_print ( id, print_chat, "%s Нож %s", PL_PREFIX, knife [ id ] ? "Включен" : "Выключен" );
	set_user_knife ( id );
	return PLUGIN_HANDLED;
}

stock set_user_knife ( id )
{
	engclient_cmd ( id, "weapon_knife" );
	switch ( knife [ id ] )
	{
		case 0:
		{
			set_pev ( id, pev_viewmodel2, "models/v_knife.mdl" );
			set_pev ( id, pev_weaponmodel2, "models/p_knife.mdl" );
		}
		case 1:
		{
			new szMdl [ 2 ][ 255 ];
			get_cvar_string ( "aknife_view_model", szMdl [ 0 ], charsmax ( szMdl [] ) );
			get_cvar_string ( "aknife_player_model", szMdl [ 1 ], charsmax ( szMdl [] ) );
			
			set_pev ( id, pev_viewmodel2, szMdl [ 0 ] );
			set_pev ( id, pev_weaponmodel2, szMdl [ 1 ] );
		}
	}
}